Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class ContainerOrderFocusTraversalPolicy

    java.lang.Object
      java.awt.FocusTraversalPolicy
          java.awt.ContainerOrderFocusTraversalPolicy

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  DefaultFocusTraversalPolicy

public class ContainerOrderFocusTraversalPolicy
extends FocusTraversalPolicy
implements Serializable

A FocusTraversalPolicy that determines traversal order based on the order of child Components in a Container. From a particular focus cycle root, the policy makes a pre-order traversal of the Component hierarchy, and traverses a Container's children according to the ordering of the array returned by `Container.getComponents()`. Portions of the hierarchy that are not visible and displayable will not be searched.

By default, ContainerOrderFocusTraversalPolicy implicitly transfers focus down-cycle. That is, during normal forward focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

By default, methods of this class with return a Component only if it is visible, displayable, enabled, and focusable. Subclasses can modify this behavior by overriding the `accept` method.

Since:
  1.4
See Also:
  `Container.getComponents()`, Serialized Form

Constructor Summary
`ContainerOrderFocusTraversalPolicy()`

Method Summary
`protected boolean` | `accept(Component aComponent)` Determines whether a Component is an acceptable choice as the new focus owner.
`Component` | `getComponentAfter(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus after aComponent.
`Component` | `getComponentBefore(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus before aComponent.
`Component` | `getDefaultComponent(Container focusCycleRoot)` Returns the default Component to focus.
`Component` | `getFirstComponent(Container focusCycleRoot)` Returns the first Component in the traversal cycle.
`boolean` | `getImplicitDownCycleTraversal()` Returns whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly.
`Component` | `getLastComponent(Container focusCycleRoot)` Returns the last Component in the traversal cycle.
`void` | `setImplicitDownCycleTraversal(boolean implicitDownCycleTraversal)` Sets whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly.

Methods inherited from class java.awt.FocusTraversalPolicy
`getInitialComponent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ContainerOrderFocusTraversalPolicy

    public ContainerOrderFocusTraversalPolicy()

Method Detail

### getComponentAfter

    public Component getComponentAfter(Container focusCycleRoot,
                                       Component aComponent)

  Returns the Component that should receive the focus after aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  By default, ContainerOrderFocusTraversalPolicy implicitly transfers focus down-cycle. That is, during normal forward focus traversal, the Component traversed after a focus cycle root will be the focus-cycle- root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

  Specified by:
    `getComponentAfter` in class `FocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus after aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getComponentBefore

    public Component getComponentBefore(Container focusCycleRoot,
                                        Component aComponent)

  Returns the Component that should receive the focus before aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  Specified by:
    `getComponentBefore` in class `FocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus before aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getFirstComponent

    public Component getFirstComponent(Container focusCycleRoot)

  Returns the first Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the forward direction.

  Specified by:
    `getFirstComponent` in class `FocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - the focus cycle root whose first Component is to be returned
  Returns:
    the first Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getLastComponent

    public Component getLastComponent(Container focusCycleRoot)

  Returns the last Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the reverse direction.

  Specified by:
    `getLastComponent` in class `FocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - the focus cycle root whose last Component is to be returned
  Returns:
    the last Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getDefaultComponent

    public Component getDefaultComponent(Container focusCycleRoot)

  Returns the default Component to focus. This Component will be the first to receive focus when traversing down into a new focus traversal cycle rooted at focusCycleRoot. The default implementation of this method returns the same Component as `getFirstComponent`.

  Specified by:
    `getDefaultComponent` in class `FocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - the focus cycle root whose default Component is to be returned
  Returns:
    the default Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null
  See Also:
    `getFirstComponent(java.awt.Container)`

### setImplicitDownCycleTraversal

    public void setImplicitDownCycleTraversal(boolean implicitDownCycleTraversal)

  Sets whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly. If `true`, during normal forward focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. If `false`, the next Component in the focus traversal cycle rooted at the specified focus cycle root will be traversed instead. The default value for this property is `true`.

  Parameters:
    `implicitDownCycleTraversal` - whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly
  See Also:
    `getImplicitDownCycleTraversal()`, `getFirstComponent(java.awt.Container)`

### getImplicitDownCycleTraversal

    public boolean getImplicitDownCycleTraversal()

  Returns whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly. If `true`, during normal forward focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. If `false`, the next Component in the focus traversal cycle rooted at the specified focus cycle root will be traversed instead.

  Returns:
    whether this ContainerOrderFocusTraversalPolicy transfers focus down-cycle implicitly
  See Also:
    `setImplicitDownCycleTraversal(boolean)`, `getFirstComponent(java.awt.Container)`

### accept

    protected boolean accept(Component aComponent)

  Determines whether a Component is an acceptable choice as the new focus owner. By default, this method will accept a Component if and only if it is visible, displayable, enabled, and focusable.

  Parameters:
    `aComponent` - the Component whose fitness as a focus owner is to be tested
  Returns:
    `true` if aComponent is visible, displayable, enabled, and focusable; `false` otherwise

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2003 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.